unit lie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls, MPlayer, Animate, Menus,
  ImgList, ActnList, XPStyleActnCtrls, ActnMan, ToolWin, ActnCtrls, Registry,
  ZlibEx, XPMan, PNGImage, JPEG, GIFImage, JvPicClip;

type
  TMainFrm = class(TForm)
    FileSection: TGroupBox;
    eOutFile: TLabeledEdit;
    FileList: TListBox;
    AddFile: TSpeedButton;
    DelFile: TSpeedButton;
    ClearFileList: TSpeedButton;
    FileLabel: TLabel;
    ImageSection: TGroupBox;
    ImageLabel: TLabel;
    ImageBox: TComboBox;
    DelImage: TSpeedButton;
    AddImage: TSpeedButton;
    eImageFile: TLabeledEdit;
    eImageX: TLabeledEdit;
    eImageY: TLabeledEdit;
    eImageTime: TLabeledEdit;
    AniPreview: TSpeedButton;
    ImageXUpDown: TUpDown;
    ImageYUpDown: TUpDown;
    ImageTimeUpDown: TUpDown;
    PreviewSection: TGroupBox;
    ObjectsSection: TGroupBox;
    AddFileDialog: TOpenDialog;
    Image: TImage;
    ObjectsBox: TComboBox;
    MapObjectList: TListBox;
    ScreenObjectList: TListBox;
    Player: TMediaPlayer;
    eObjectX: TLabeledEdit;
    eObjectY: TLabeledEdit;
    ObjectImageBox: TComboBox;
    ObjectImageLabel: TLabel;
    ObjectLayerBox: TComboBox;
    ObjectLayerLabel: TLabel;
    ObjectModeLabel: TLabel;
    ObjectModeBox: TComboBox;
    eObjectDsplyTime: TLabeledEdit;
    eObjectID: TLabeledEdit;
    DsplyTimeUpDown: TUpDown;
    ObjectIDUpDown: TUpDown;
    AddObject: TSpeedButton;
    DelObject: TSpeedButton;
    ClearObjectList: TSpeedButton;
    ApplyObject: TSpeedButton;
    PrevErrorLabel: TLabel;
    Timer: TTimer;
    SortObjects: TSpeedButton;
    Presets: TSpeedButton;
    PresetPopUp: TPopupMenu;
    CenterSafe: TMenuItem;
    SplashScreenCenter: TMenuItem;
    Switch: TSpeedButton;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    New1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    About1: TMenuItem;
    ImageList: TImageList;
    LieHelp1: TMenuItem;
    ActionToolBar1: TActionToolBar;
    OpenFileDialog: TOpenDialog;
    SaveFileDialog: TSaveDialog;
    Status: TStatusBar;
    Progress: TProgressBar;
    ProgressLabel: TLabel;
    ActionManager: TActionManager;
    New: TAction;
    aOpen: TAction;
    Save: TAction;
    SaveAs: TAction;
    Exit: TAction;
    Compile: TAction;
    XPManifest: TXPManifest;
    AnimTimer: TTimer;
    PicClip: TJvPicClip;
    BackgroundTiledMajick1: TMenuItem;
    procedure AddFileClick(Sender: TObject);
    procedure DelFileClick(Sender: TObject);
    procedure ClearFileListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ObjectsBoxChange(Sender: TObject);
    procedure ClearObjectListClick(Sender: TObject);
    procedure ImageBoxChange(Sender: TObject);
    procedure AniPreviewClick(Sender: TObject);
    procedure AddImageClick(Sender: TObject);
    procedure DelImageClick(Sender: TObject);
    procedure FileListDblClick(Sender: TObject);
    procedure eImageFileKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eImageXKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eImageYKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eImageTimeKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimerTimer(Sender: TObject);
    procedure ImageXUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure ImageYUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure ImageTimeUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure MapObjectListClick(Sender: TObject);
    procedure ScreenObjectListClick(Sender: TObject);
    procedure AddObjectClick(Sender: TObject);
    procedure ApplyObjectClick(Sender: TObject);
    procedure DelObjectClick(Sender: TObject);
    procedure SortObjectsClick(Sender: TObject);
    procedure eObjectXKeyPress(Sender: TObject; var Key: Char);
    procedure eObjectYKeyPress(Sender: TObject; var Key: Char);
    procedure eObjectXExit(Sender: TObject);
    procedure eObjectYExit(Sender: TObject);
    procedure PresetsClick(Sender: TObject);
    procedure CenterSafeClick(Sender: TObject);
    procedure SplashScreenCenterClick(Sender: TObject);
    procedure SwitchClick(Sender: TObject);
    procedure aOpenExecute(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure NewExecute(Sender: TObject);
    procedure SaveAsExecute(Sender: TObject);
    procedure SaveExecute(Sender: TObject);
    procedure CompileExecute(Sender: TObject);
    procedure LieHelp1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ExitExecute(Sender: TObject);
    procedure AnimTimerTimer(Sender: TObject);
    procedure ImageXUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure BackgroundTiledMajick1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Open(Datei:String);
    procedure UpdateBoxes;
    procedure UpdateArrays(MapObjects:Boolean);
    procedure NewIni;
    procedure SaveIni(Datei:String);
    function ValidGFX(Extension:String):Boolean;
    procedure HideImage;
  end;

var
  MainFrm: TMainFrm;
  Collect,Anim: Boolean;
  AppPath,IniPath,Compiler,Title,Ini: String;
  Images,ImageX,ImageY,ImageT: Array of Integer;
  MapCount,ScreenCount,ImageCount,XTile,YTile: Integer;
  MapX,MapY,ScreenX,ScreenY,ImageFile: Array of String;
  MapImage,MapLayer,MapMode,MapTime,MapID: Array of Integer;
  ScreenImage,ScreenLayer,ScreenMode,ScreenTime,ScreenID: Array of Integer;

  function GetImageFile(Source:String):String;
  function GetObjectXY(Source:String;Commas:Integer):String;
  function GetOption(Source:String;Commas:Integer;Image:Boolean):Integer;
  procedure QSort(Links, Rechts: LongInt; SortBy: Integer; MapObject: Boolean);

implementation

uses Sort, Optns, About;

{$R *.dfm}

procedure TMainFrm.HideImage;
begin
  Image.Visible := False;
end;

function TMainFrm.ValidGFX(Extension:String):Boolean;
begin
  ValidGFX := False;
  Extension := Lowercase(Extension);
  If (Extension = '.bmp') or (Extension = '.bm2') or (Extension = '.gif')
  or (Extension = '.jpg') or (Extension = '.jpeg') or (Extension = '.png') then
  begin
    ValidGFX := True;
  end;
end;

procedure TMainFrm.SaveIni(Datei:String);
var f: TextFile;
    i: Integer;
    Line: String;
begin
  Ini := Datei;
  IniPath := ExtractFilePath(Ini);
  MainFrm.Caption := Title + ' - ' + ExtractFileName(Ini);
  Status.Panels[0].Text := Ini;
  AssignFile(f,Datei);
  ReWrite(f);
  WriteLn(f,'OutFile=' + eOutFile.Text);
  WriteLn(f,'');
  For i := 0 to FileList.Items.Count - 1 do
  begin
    WriteLn(f,'File=' + FileList.Items[i]);
  end;
  If ImageBox.Items.Count > 0 then
  begin
    WriteLn(f,'');
    WriteLn(f,'[objectimages]');
  end;
  For i := 0 to ImageBox.Items.Count -1 do
  begin
    Line := 'IMAGE' + IntToStr(Images[i]) + '=' + ImageFile[i];
    If ((ImageX[i] <> 0) and (ImageX[i] <> -1))
      and ((ImageY[i] <> 0) and (ImageY[i] <> -1))
      and ((ImageT[i] <> 0) and (ImageT[i] <> -1)) then
    begin
      Line := Line + ',' + IntToStr(ImageX[i]) + ',' + IntToStr(ImageY[i]) + ',' + IntToStr(ImageT[i]);
    end;
    WriteLn(f,Line);
  end;
  If (MapCount > 0) then
  begin
    WriteLn(f,'');
    WriteLn(f,'[mapobjects]');
    For i := 0 to MapObjectList.Items.Count - 1 do
    begin
      WriteLn(f,MapObjectList.Items[i]);
    end;
  end;
    If (ScreenCount > 0) then
  begin
    WriteLn(f,'');
    WriteLn(f,'[screenobjects]');
    For i := 0 to ScreenObjectList.Items.Count - 1 do
    begin
      WriteLn(f,ScreenObjectList.Items[i]);
    end;
  end;
  CloseFile(f);
end;

procedure TMainFrm.NewIni;
begin
  MapCount := 0;
  ScreenCount := 0;
  ImageCount := 0;
  Ini := '';
  IniPath := '';
  MainFrm.Caption := Title;
  Status.Panels[0].Text := '';
  FileList.Clear;
  ScreenObjectList.Clear;
  MapObjectList.Clear;
  ImageBox.Clear;
  ObjectsBox.ItemIndex := 0;
  ScreenObjectList.Visible := False;
  MapObjectList.Visible := True;
  Image.Visible := False;
  Progress.Visible := False;
  ProgressLabel.Visible := False;

  eOutFile.Text := '';
  eImageFile.Text := '';
  eImageX.Text := '0';
  eImageY.Text := '0';
  eImageTime.Text := '0';
  ImageBox.ItemIndex := -1;
  ImageBox.Text := 'IMAGE#';
  ObjectImageBox.ItemIndex := -1;
  ObjectImageBox.Text := 'IMAGE#';
  eObjectX.Text := '';
  eObjectY.Text := '';
  ObjectLayerBox.ItemIndex := -1;
  ObjectLayerBox.Text := 'Layer';
  ObjectModeBox.ItemIndex := -1;
  ObjectModeBox.Text := 'Mode';
  eObjectDsplyTime.Text := '0';
  eObjectID.Text := '0';


  SetLength(Images,0);
  SetLength(ImageT,0);
  SetLength(ImageY,0);
  SetLength(ImageX,0);
  SetLength(ImageFile,0);
  SetLength(MapX,0);
  SetLength(MapY,0);
  SetLength(MapImage,0);
  SetLength(MapLayer,0);
  SetLength(MapMode,0);
  SetLength(MapTime,0);
  SetLength(MapID,0);
  SetLength(ScreenX,0);
  SetLength(ScreenY,0);
  SetLength(ScreenImage,0);
  SetLength(ScreenLayer,0);
  SetLength(ScreenMode,0);
  SetLength(ScreenTime,0);
  SetLength(ScreenID,0);
end;

//function to get the file out of one image-line
function GetImageFile(Source:String):String;
var i: Integer;
    Help: String;
    iFile: Boolean;
begin
  iFile := False;
  For i := 1 to Length(Source) do
  begin
    If Copy(Source,i,1) = ',' then iFile := False;
    If iFile then
    begin
      Help := Help + Copy(Source,i,1);
    end;
    If Copy(Source,i,1) = '=' then iFile := True;
  end;
  GetImageFile := Help;
end;

//procedure that reads the ini into several arrays
procedure TMainFrm.Open(Datei:String);
var f: TextFile;
    section,Flag,i: integer;
    Line,Help: string;
begin
  MapCount := 0;
  ScreenCount := 0;
  ImageCount := 0;
  section := 0;
  AssignFile(f,Datei);
  Reset(f);
  while not EOF(f) do
  begin
    Flag := 0;
    ReadLn(f,Line);
    If (LowerCase(Copy(Line,1,7)) = 'outfile') then
    begin
      eOutFile.Text := Copy(Line,9,Length(Line)-8);
    end;
    If (LowerCase(Copy(Line,1,4)) = 'file') then
    begin
      FileList.Items.Add(Copy(Line,6,Length(Line)-5));
    end;
    If (LowerCase(Copy(Line,1,14)) = '[objectimages]') then
    begin
      section := 1;
      Flag := 1;
    end;
    If (LowerCase(Copy(Line,1,12)) = '[mapobjects]') then
    begin
      section := 2;
      Flag := 1;
    end;
    If (LowerCase(Copy(Line,1,15)) = '[screenobjects]') then
    begin
      section := 3;
      Flag := 1;
    end;
    If (Flag = 0) then
    begin
      if (section = 1) and (Copy(Line,1,1) <> ';') and (Length(Line) <> 0) then
      begin
        // ObjectImages
        ImageCount := ImageCount + 1;

        {Get ImageNumber}
        Help := '';
        For i := 1 to Length(Line) do
        begin
          Help := Help + Copy(Line,i,1);
          If Copy(Line,i,1) = '=' then
          begin
            Help := Copy(Help,1,Length(Help)-1);
            Help := Copy(Help,6,Length(Help)-5);
            SetLength(Images,ImageCount);
            SetLength(ImageT,ImageCount);
            SetLength(ImageY,ImageCount);
            SetLength(ImageX,ImageCount);
            SetLength(ImageFile,ImageCount);
            Images[ImageCount-1] := StrToInt(Help);
            ImageBox.Items.Add('IMAGE'+IntToStr(Images[ImageCount-1]));
          end;
        end;

        {Get File of the Image}
        Help := GetImageFile(Line);
        ImageFile[ImageCount-1] := Help;

        {Other attributes}
        ImageX[ImageCount-1] := GetOption(Line,1,True);
        ImageY[ImageCount-1] := GetOption(Line,2,True);
        ImageT[ImageCount-1] := GetOption(Line,3,True);

      end;
      if (section = 2) and (Copy(Line,1,1) <> ';') and (Length(Line) <> 0) then
      begin
        // MapObjects
        MapObjectList.Items.Add(Line);
        MapCount := MapCount + 1;

        SetLength(MapX,MapCount);
        SetLength(MapY,MapCount);
        SetLength(MapImage,MapCount);
        SetLength(MapLayer,MapCount);
        SetLength(MapMode,MapCount);
        SetLength(MapTime,MapCount);
        SetLength(MapID,MapCount);

        MapX[MapCount-1] := IntToStr(GetOption(Line,0,False));
        MapY[MapCount-1] := IntToStr(GetOption(Line,1,False));
        MapImage[MapCount-1] := GetOption(Line,2,False);
        MapLayer[MapCount-1] := GetOption(Line,3,False);
        MapMode[MapCount-1] := GetOption(Line,4,False);
        MapTime[MapCount-1] := GetOption(Line,5,False);
        MapID[MapCount-1] := GetOption(Line,6,False);
      end;
      if (section = 3) and (Copy(Line,1,1) <> ';') and (Length(Line) <> 0) then
      begin
        // ScreenObjects
        ScreenObjectList.Items.Add(Line);
        ScreenCount := ScreenCount + 1;

        SetLength(ScreenX,ScreenCount);
        SetLength(ScreenY,ScreenCount);
        SetLength(ScreenImage,ScreenCount);
        SetLength(ScreenLayer,ScreenCount);
        SetLength(ScreenMode,ScreenCount);
        SetLength(ScreenTime,ScreenCount);
        SetLength(ScreenID,ScreenCount);

        ScreenX[ScreenCount-1] := GetObjectXY(Line,0);
        ScreenY[ScreenCount-1] := GetObjectXY(Line,1);
        ScreenImage[ScreenCount-1] := GetOption(Line,2,False);
        ScreenLayer[ScreenCount-1] := GetOption(Line,3,False);
        ScreenMode[ScreenCount-1] := GetOption(Line,4,False);
        ScreenTime[ScreenCount-1] := GetOption(Line,5,False);
        ScreenID[ScreenCount-1] := GetOption(Line,6,False);
      end;
    end;
  end;
  CloseFile(f);
end;

function GetObjectXY(Source:String;Commas:Integer):String;
var CommasCount,i: Integer;
    Help,Part: String;
begin
  Source := Source + ',';
  CommasCount := 0;
  For i := 1 to Length(Source) do
  begin
    Part := Copy(Source,i,1);
    If Part = ',' then CommasCount := CommasCount + 1;
    If CommasCount = Commas then
    begin
      Help := Help + Part;
    end;
    If CommasCount = (Commas + 1) then
    begin
      If Commas <> 0 then Help := Copy(Help,2,Length(Help));
      GetObjectXY := Help;
      exit;
    end;
  end;
  GetObjectXY := '-1';
end;

// A cool function that gets the text between 2 commas!
//Output is an integer, so it modifies the text to fit lvz-format :)
function GetOption(Source:String;Commas:Integer;Image:Boolean):Integer;
var CommasCount,i: Integer;
    Help,Part: String;
begin
  Source := Source + ',';
  CommasCount := 0;
  For i := 1 to Length(Source) do
  begin
    Part := Copy(Source,i,1);
    If Part = ',' then CommasCount := CommasCount + 1;
    If CommasCount = Commas then
    begin
      Help := Help + Part;
    end;
    If CommasCount = (Commas + 1) then
    begin
      If Commas <> 0 then Help := Copy(Help,2,Length(Help));

      Help := Lowercase(Help);

      If (Copy(Help,1,5) = 'image') and (Image = False) then Help := Copy(Help,6,Length(Help)-5);

      If Help = 'belowall' then Help := '0';
      If Help = 'afterbackground' then Help := '1';
      If Help = 'aftertiles' then Help := '2';
      If Help = 'afterweapons' then Help := '3';
      If Help = 'afterships' then Help := '4';
      If Help = 'aftergauges' then Help := '5';
      If Help = 'afterchat' then Help := '6';
      If Help = 'topmost' then Help := '7';

      If Help = 'showalways' then Help := '0';
      If Help = 'enterzone' then Help := '1';
      If Help = 'enterarena' then Help := '2';
      If Help = 'kill' then Help := '3';
      If Help = 'death' then Help := '4';
      If Help = 'servercontrolled' then Help := '5';

      GetOption := StrToInt(Help);
      exit;
    end;
  end;
  GetOption := -1;
end;

procedure TMainFrm.AddFileClick(Sender: TObject);
var i: Integer;
begin
  If (AddFileDialog.Execute) then
  begin
    For i:= 0 to AddFileDialog.Files.Count - 1 do
    begin
      FileList.Items.Add(ExtractFileName(AddFileDialog.Files[i]));
      If ((Collect) and (IniPath <> '')) then
      begin
        If (FileExists(IniPath + ExtractFileName(AddFileDialog.Files[i])) = False) then
        begin
          CopyFile(PChar(AddFileDialog.Files[i]),PChar(IniPath + ExtractFileName(AddFileDialog.Files[i])),True);
        end;
      end;
    end;
  end;
end;

procedure TMainFrm.DelFileClick(Sender: TObject);
begin
  FileList.DeleteSelected;
end;

procedure TMainFrm.ClearFileListClick(Sender: TObject);
begin
  FileList.Clear;
  Image.Visible := False;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
var reg: TRegistry;
    i: Integer;
begin
  AppPath := ExtractFilePath(ParamStr(0));
  IniPath := '';
  Title := 'LIE v2 [Lvz Ini Editor]';
  reg := TRegistry.Create;
    reg.OpenKey('Software\k0zy\LIEv2',True);
    Compiler := reg.ReadString('Compiler');
    i := 0;
    try
      i := reg.ReadInteger('Collect');
    except
      reg.WriteInteger('Collect',1); Collect := True;
    end;
    if (i = 0) then Collect := False
    ELSE Collect := True;
  reg.Free;
end;

procedure TMainFrm.FileListClick(Sender: TObject);
var bm2: TBitmap;
begin
  Anim := False;
  PrevErrorLabel.Caption := '';
  PrevErrorLabel.Visible := False;
  Player.Visible := False;
  Player.Close;
  If (ValidGFX(ExtractFileExt(FileList.Items[FileList.ItemIndex]))
   and (FileExists(IniPath + FileList.Items[FileList.ItemIndex]))) then
  begin
    Image.Visible := True;
    Progress.Visible := False;
    ProgressLabel.Visible := False;
    If LowerCase(ExtractFileExt(FileList.Items[FileList.ItemIndex])) = '.bm2' then
    begin
      bm2 := TBitmap.Create;
      bm2.LoadFromFile(IniPath + FileList.Items[FileList.ItemIndex]);
      Image.Picture.Assign(bm2);
      bm2.Free;
    end
    ELSE
    begin
      Image.Picture.LoadFromFile(IniPath + FileList.Items[FileList.ItemIndex]);
    end;
  end
  ELSE
  begin
    If (LowerCase(ExtractFileExt(FileList.Items[FileList.ItemIndex])) = '.bmp')
       or (LowerCase(ExtractFileExt(FileList.Items[FileList.ItemIndex])) = '.bm2') then
    begin
      Image.Visible := False;
      Progress.Visible := False;
      ProgressLabel.Visible := False;
      PrevErrorLabel.Visible := True;
      PrevErrorLabel.Caption := 'Unable to find' + #13 + 'the current image...';
    end
    ELSE
    begin
      ProgressLabel.Visible := False;
      Image.Visible := False;
      Progress.Visible := False;
      If (LowerCase(ExtractFileExt(FileList.Items[FileList.ItemIndex])) = '.wav') or
         (LowerCase(ExtractFileExt(FileList.Items[FileList.ItemIndex])) = '.wa2') then
      begin
        If (FileExists(IniPath + FileList.Items[FileList.ItemIndex])) then
        begin
          Player.Visible := True;
          CopyFile(PChar(IniPath + FileList.Items[FileList.ItemIndex]),PChar(AppPath+'prev.wav'),False);
          Player.filename:= AppPath + 'prev.wav';
          Player.open;
          Player.wait:=true;
        end;
      end;
    end;
  end;
end;

procedure TMainFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Player.Close;
  SleepEx(100,False);
  If (FileExists(AppPath + 'prev.wav')) then
  begin
    DeleteFile(AppPath + 'prev.wav');
  end;;
end;

procedure TMainFrm.ObjectsBoxChange(Sender: TObject);
begin
  If ObjectsBox.ItemIndex = 0 then
  begin
    ScreenObjectList.Visible := False;
    MapObjectList.Visible := True;
  end;
  If ObjectsBox.ItemIndex = 1 then
  begin
    ScreenObjectList.Visible := True;
    MapObjectList.Visible := False;
  end;
end;

procedure TMainFrm.ClearObjectListClick(Sender: TObject);
begin
  Case ObjectsBox.ItemIndex of
   -1,0: begin MapObjectList.Clear; UpdateArrays(True); end;
    1: begin ScreenObjectList.Clear; UpdateArrays(False); end;
  end;
end;

procedure TMainFrm.ImageBoxChange(Sender: TObject);
begin
  eImageFile.Text := ImageFile[ImageBox.ItemIndex];
  eImageX.Text := IntToStr(ImageX[ImageBox.ItemIndex]);
  If ImageX[ImageBox.ItemIndex] = -1 then eImageX.Text := '';
  eImageY.Text := IntToStr(ImageY[ImageBox.ItemIndex]);
  If ImageY[ImageBox.ItemIndex] = -1 then eImageY.Text := '';
  eImageTime.Text := IntToStr(ImageT[ImageBox.ItemIndex]);
  If ImageT[ImageBox.ItemIndex] = -1 then eImageTime.Text := '';
  If Anim then Image.Visible := False;
end;

procedure TMainFrm.AniPreviewClick(Sender: TObject);
begin
  Image.Visible := True;
  PrevErrorLabel.Visible := False;
  Progress.Visible := False;
  PrevErrorLabel.Caption := '';
  Player.Close;
  Player.Visible := False;
  If FileExists(IniPath + eImageFile.Text) then
  begin
    PicClip.Picture.LoadFromFile(IniPath + eImageFile.Text);
    If Length(eImageX.Text) = 0 then
    begin
      Image.Visible := False;
      PrevErrorLabel.Visible := True;
      PrevErrorLabel.Caption := 'X-Tiles not entered!';
    end
    ELSE
    begin
      PicClip.Cols := StrToInt(eImageX.Text);
    end;
    If Length(eImageY.Text) = 0 then
    begin
      Image.Visible := False;
      PrevErrorLabel.Visible := True;
      PrevErrorLabel.Caption := 'Y-Tiles not entered!';
    end
    ELSE
    begin
      PicClip.Rows := StrToInt(eImageY.Text);
    end;
    If Length(eImageTime.Text) = 0 then
    begin
      Image.Visible := False;
      PrevErrorLabel.Visible := True;
      PrevErrorLabel.Caption := 'AniTime not entered!';
    end
    ELSE
    begin
      AnimTimer.Interval := StrToInt(eImageTime.Text) * 10 div (StrToInt(eImageX.Text)*StrToInt(eImageY.Text)); 
    end;
    XTile := 0;
    YTile := 0;
    Anim := True;
    Image.Picture.Assign(PicClip.Cells[XTile,YTile]);
    XTile := XTile + 1;
    If XTile > PicClip.Cols-1 then
    begin
      XTile := 0;
      YTile := YTile + 1;
      If YTile > PicClip.Rows-1 then
      begin
        YTile := 0;
      end;
    end;
  end
  ELSE
  begin
    Image.Visible := False;
    PrevErrorLabel.Visible := True;
    PrevErrorLabel.Caption := 'File not found!';
  end;
end;

procedure TMainFrm.AddImageClick(Sender: TObject);
begin
  ImageCount := ImageCount + 1;
  SetLength(Images,ImageCount);
  SetLength(ImageFile,ImageCount);
  SetLength(ImageX,ImageCount);
  SetLength(ImageY,ImageCount);
  SetLength(ImageT,ImageCount);
  Images[ImageCount-1] := ImageCount-1;
  ImageX[ImageCount-1] := -1;
  ImageY[ImageCount-1] := -1;
  ImageT[ImageCount-1] := -1;
  ImageBox.Items.Add('IMAGE'+IntToStr(ImageCount-1));
  ImageBox.ItemIndex := ImageBox.Items.Count - 1;
  eImageFile.Text := ImageFile[ImageBox.ItemIndex];
  eImageX.Text := IntToStr(ImageX[ImageBox.ItemIndex]);
  If ImageX[ImageBox.ItemIndex] = -1 then eImageX.Text := '';
  eImageY.Text := IntToStr(ImageY[ImageBox.ItemIndex]);
  If ImageY[ImageBox.ItemIndex] = -1 then eImageY.Text := '';
  eImageTime.Text := IntToStr(ImageT[ImageBox.ItemIndex]);
  If ImageT[ImageBox.ItemIndex] = -1 then eImageTime.Text := '';
  If Anim then Image.Visible := False;
end;

procedure TMainFrm.UpdateBoxes;
var i,Flag: integer;
    New: String;
begin
  MapObjectList.Clear;
  ScreenObjectList.Clear;

  //MapObjects
  For i := 0 to MapCount - 1 do
  begin
    Flag := 0;
    New := MapX[i]  + ',' + MapY[i] + ',' + 'IMAGE' + IntToStr(MapImage[i]) + ',';
    Case MapLayer[i] of
      0: New := New + 'BelowAll';
      1: New := New + 'AfterBackground';
      2: New := New + 'AfterTiles';
      3: New := New + 'AfterWeapons';
      4: New := New + 'AfterShips';
      5: New := New + 'AfterGauges';
      6: New := New + 'AfterChat';
      7: New := New + 'TopMost';
    end;
    If MapMode[i] = -1 then Flag := 1;
    If (Flag <> 1) then
    begin
      Case MapMode[i] of
        0: New := New + ',ShowAlways';
        1: New := New + ',EnterZone';
        2: New := New + ',EnterArena';
        3: New := New + ',Kill';
        4: New := New + ',Death';
        5: New := New + ',ServerControlled';
      end;
    end;
    If (MapTime[i] = -1) or (MapTime[i] = 0) and (Flag = 0) then
    begin
      Flag := 1;
    end;
    If (Flag <> 1) then
    begin
       New := New + ',' + IntToStr(MapTime[i]);
    end;
    If (MapID[i] = -1) or (MapID[i] = 0) and (Flag = 0) then
    begin
      Flag := 1;
    end;
    If (Flag <> 1) then
    begin
      New := New + ',' + IntToStr(MapID[i]);
    end;
    MapObjectList.Items.Add(New);
  end;

  //ScreenObjects
  For i := 0 to ScreenCount - 1 do
  begin
    Flag := 0;
    New := ScreenX[i]  + ',' + ScreenY[i] + ',' + 'IMAGE' + IntToStr(ScreenImage[i]) + ',';
    Case ScreenLayer[i] of
      0: New := New + 'BelowAll';
      1: New := New + 'AfterBackground';
      2: New := New + 'AfterTiles';
      3: New := New + 'AfterWeapons';
      4: New := New + 'AfterShips';
      5: New := New + 'AfterGauges';
      6: New := New + 'AfterChat';
      7: New := New + 'TopMost';
    end;
    If ScreenMode[i] = -1 then Flag := 1;
    If (Flag <> 1) then
    begin
      Case ScreenMode[i] of
        0: New := New + ',ShowAlways';
        1: New := New + ',EnterZone';
        2: New := New + ',EnterArena';
        3: New := New + ',Kill';
        4: New := New + ',Death';
        5: New := New + ',ServerControlled';
      end;
    end;
    If (ScreenTime[i] = -1) or (ScreenTime[i] = 0) and (Flag = 0) then
    begin
      Flag := 1;
    end;
    If (Flag <> 1) then
    begin
       New := New + ',' + IntToStr(ScreenTime[i]);
    end;
    If (ScreenID[i] = -1) or (ScreenID[i] = 0) and (Flag = 0) then
    begin
      Flag := 1;
    end;
    If (Flag <> 1) then
    begin
      New := New + ',' + IntToStr(ScreenID[i]);
    end;
    ScreenObjectList.Items.Add(New);
  end;
end;

procedure TMainFrm.UpdateArrays(MapObjects:Boolean);
var i: integer;
    Line: String;
begin
  If MapObjects then
  begin
    MapCount := 0;
    For i := 0 to MapObjectList.Items.Count -1 do
    begin
      // MapObjects
      Line := MapObjectList.Items[i];
      MapCount := MapCount + 1;

      SetLength(MapX,MapCount);
      SetLength(MapY,MapCount);
      SetLength(MapImage,MapCount);
      SetLength(MapLayer,MapCount);
      SetLength(MapMode,MapCount);
      SetLength(MapTime,MapCount);
      SetLength(MapID,MapCount);

      MapX[MapCount-1] := IntToStr(GetOption(Line,0,False));
      MapY[MapCount-1] := IntToStr(GetOption(Line,1,False));
      MapImage[MapCount-1] := GetOption(Line,2,False);
      MapLayer[MapCount-1] := GetOption(Line,3,False);
      MapMode[MapCount-1] := GetOption(Line,4,False);
      MapTime[MapCount-1] := GetOption(Line,5,False);
      MapID[MapCount-1] := GetOption(Line,6,False);
    end;
  end
  ELSE
  begin
    // ScreenObjects
    ScreenCount := 0;
    For i := 0 to ScreenObjectList.Items.Count - 1 do
    begin
      Line := ScreenObjectList.Items[i];
      ScreenCount := ScreenCount + 1;

      SetLength(ScreenX,ScreenCount);
      SetLength(ScreenY,ScreenCount);
      SetLength(ScreenImage,ScreenCount);
      SetLength(ScreenLayer,ScreenCount);
      SetLength(ScreenMode,ScreenCount);
      SetLength(ScreenTime,ScreenCount);
      SetLength(ScreenID,ScreenCount);

      ScreenX[ScreenCount-1] := GetObjectXY(Line,0);
      ScreenY[ScreenCount-1] := GetObjectXY(Line,1);
      ScreenImage[ScreenCount-1] := GetOption(Line,2,False);
      ScreenLayer[ScreenCount-1] := GetOption(Line,3,False);
      ScreenMode[ScreenCount-1] := GetOption(Line,4,False);
      ScreenTime[ScreenCount-1] := GetOption(Line,5,False);
      ScreenID[ScreenCount-1] := GetOption(Line,6,False);
    end;
  end;
end;

procedure TMainFrm.DelImageClick(Sender: TObject);
var i,deleted,ItemCount,count,image: Integer;
begin
  deleted := ImageBox.ItemIndex;
  If Anim then HideImage; 
  If (ImageBox.ItemIndex <> -1) and (MessageDlg('Delete ' + #39 + ImageBox.Items[ImageBox.ItemIndex] + #39 + '?', mtConfirmation,
     [mbYes, mbNo], 0) = mrYes) then
  begin
    For i := ImageBox.ItemIndex to ImageBox.Items.Count - 2 do
    begin
      ImageFile[i] := ImageFile[i+1];
      ImageX[i] := ImageX[i+1];
      ImageY[i] := ImageY[i+1];
      ImageT[i] := ImageT[i+1];
    end;
    deleted := ImageBox.ItemIndex;
    ImageBox.Items.Delete(ImageBox.ItemIndex);
    For i := 0 to ImageBox.Items.Count - 1 do
    begin
      ImageBox.Items[i] := 'IMAGE' + IntToStr(i);
    end;
    ObjectImageBox.Items := ImageBox.Items;
    eImageFile.Text := '';
    eImageX.Text := '';
    eImageY.Text := '';
    eImageTime.Text := '';

    ImageCount := ImageCount - 1;
    SetLength(Images,ImageCount);
    SetLength(ImageFile,ImageCount);
    SetLength(ImageX,ImageCount);
    SetLength(ImageY,ImageCount);
    SetLength(ImageT,ImageCount);


    if ((MessageDlg('Apply Changes to the Objects?', mtConfirmation,
       [mbYes, mbNo], 0)) = mrYes) then
    begin

      // MapObjects
      ItemCount := MapObjectList.Items.Count;
      count := 0;
      For i := 0 to ItemCount - 1 do
      begin
        image := MapImage[i];
        If image = deleted then
        begin
          MapObjectList.Items.Delete(i-count);
          count := count + 1;
        end;
      end;
      UpdateArrays(True);
      ItemCount := MapObjectList.Items.Count;
      For i := 0 to ItemCount - 1 do
      begin
        image := MapImage[i];
        If image > deleted then
        begin
          MapImage[i] := image - 1;
        end;
      end;
      UpdateBoxes;

      // ScreenObjects
      ItemCount := ScreenObjectList.Items.Count;
      count := 0;
      For i := 0 to ItemCount - 1 do
      begin
        If ScreenImage[i] = deleted then
        begin
          ScreenObjectList.Items.Delete(i-count);
          count := count + 1;
        end;
      end;
      UpdateArrays(False);
      ItemCount := ScreenObjectList.Items.Count;
      For i := 0 to ItemCount - 1 do
      begin
        image := ScreenImage[i];
        If image > deleted then
        begin
          ScreenImage[i] := image-1;
        end;
      end;
      UpdateBoxes;
    end;
  end;
  If (ImageBox.Items.Count = 0) then
  begin
    ImageBox.Text := 'IMAGE#';
    eImageFile.Text := '';
    eImageX.Text := '0';
    eImageY.Text := '0';
    eImageTime.Text := '0';
  end;

  ImageBox.ItemIndex := deleted - 1;
  If ImageBox.ItemIndex > -1 then
  begin
    eImageFile.Text := ImageFile[ImageBox.ItemIndex];
    eImageX.Text := IntToStr(ImageX[ImageBox.ItemIndex]);
    If ImageX[ImageBox.ItemIndex] = -1 then eImageX.Text := '';
    eImageY.Text := IntToStr(ImageY[ImageBox.ItemIndex]);
    If ImageY[ImageBox.ItemIndex] = -1 then eImageY.Text := '';
    eImageTime.Text := IntToStr(ImageT[ImageBox.ItemIndex]);
    If ImageT[ImageBox.ItemIndex] = -1 then eImageTime.Text := '';
  end;

end;

procedure TMainFrm.FileListDblClick(Sender: TObject);
begin

  if (Imagebox.ItemIndex > -1) and (ValidGFX(ExtractFileExt(FileList.Items[FileList.ItemIndex]))) then //((ExtractFileExt(FileList.Items[FileList.ItemIndex]) = '.bmp') or (ExtractFileExt(FileList.Items[FileList.ItemIndex]) = '.bm2')) then
    begin
    If (ImageFile[ImageBox.ItemIndex] <> '') then
    begin
      If (MessageDlg('Change ' + ImageBox.Items[ImageBox.ItemIndex] + ' from ' + #39 + ImageFile[ImageBox.ItemIndex] + #39 + ' to ' + #39 + FileList.Items[FileList.ItemIndex] + #39 + '?', mtConfirmation,
         [mbYes, mbNo], 0)) = mrYes then
      begin
        ImageFile[ImageBox.ItemIndex] := FileList.Items[FileList.ItemIndex];
        eImageFile.Text := ImageFile[ImageBox.ItemIndex];
      end;
    end
    ELSE
    begin
      ImageFile[ImageBox.ItemIndex] := FileList.Items[FileList.ItemIndex];
      eImageFile.Text := ImageFile[ImageBox.ItemIndex];
    end;
  end;
end;

procedure TMainFrm.eImageFileKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    ImageFile[ImageBox.ItemIndex] := eImageFile.Text;
  end;
end;

procedure TMainFrm.eImageXKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    If Length(eImageX.Text) > 0 then
    begin
      ImageX[ImageBox.ItemIndex] := StrToInt(eImageX.Text);
    end
    ELSE
    begin
      ImageX[ImageBox.ItemIndex] := -1;
    end;
  end;
end;

procedure TMainFrm.eImageYKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    If Length(eImageY.Text) > 0 then
    begin
      ImageY[ImageBox.ItemIndex] := StrToInt(eImageY.Text);
    end
    ELSE
    begin
      ImageY[ImageBox.ItemIndex] := -1;
    end;
  end;
end;

procedure TMainFrm.eImageTimeKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    If Length(eImageTime.Text) > 0 then
    begin
      ImageT[ImageBox.ItemIndex] := StrToInt(eImageTime.Text);
    end
    ELSE
    begin
      ImageT[ImageBox.ItemIndex] := -1;
    end;
  end;
end;


procedure TMainFrm.TimerTimer(Sender: TObject);
begin
  If ImageBox.Items.Count <> ObjectImageBox.Items.Count then
  begin
    ObjectImageBox.Items := ImageBox.Items;
  end;
  If (eImageFile.Text = '') or (eImageX.Text = '') or (eImageY.Text = '') or (eImageTime.Text = '') then AniPreview.Enabled := False;
  If (eImageFile.Text <> '') and (eImageY.Text <> '') and (eImageTime.Text <> '') then
  begin
    If (Length(eImageX.Text) > 0) and (Length(eImageY.Text) > 0) and (Length(eImageTime.Text) > 0) then
    begin
      If (StrToInt(eImageX.Text) > 0) and (StrToInt(eImageY.Text) > 0) and (StrToInt(eImageTime.Text) > 0) then
      begin
      AniPreview.Enabled := True;
      end
      ELSE
      begin
        AniPreview.Enabled := False;
      end;
    end
    ELSE
    begin
      AniPreview.Enabled := False;
    end;
  end;

  If (ObjectsBox.ItemIndex < 1) and (MapCount < 1) then
  begin
    SortObjects.Enabled := False;
  end;
  If (ObjectsBox.ItemIndex < 1) and (MapCount > 1) then
  begin
    SortObjects.Enabled := True;
  end;
  If (ObjectsBox.ItemIndex = 1) and (ScreenCount < 1) then
  begin
    SortObjects.Enabled := False;
  end;
  If (ObjectsBox.ItemIndex = 1) and (ScreenCount > 1) then
  begin
    SortObjects.Enabled := True;
  end;

  If (ObjectsBox.ItemIndex < 1) and (MapCount > 0) then
  begin
    Switch.Enabled := True;
    ClearObjectList.Enabled := True;
  end;
  If (ObjectsBox.ItemIndex < 1) and (MapCount = 0) then
  begin
    Switch.Enabled := False;
    ClearObjectList.Enabled := False;
  end;
  If (ObjectsBox.ItemIndex = 1) and (ScreenCount > 0) then
  begin
    Switch.Enabled := True;
    ClearObjectList.Enabled := True;
  end;
  If (ObjectsBox.ItemIndex = 1) and (ScreenCount = 0) then
  begin
    Switch.Enabled := False;
    ClearObjectList.Enabled := False;
  end;
  If FileList.Items.Count = 0 then ClearFileList.Enabled := False
  ELSE ClearFileList.Enabled := True;
end;

procedure TMainFrm.ImageXUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    ImageX[ImageBox.ItemIndex] := NewValue;
  end;
end;

procedure TMainFrm.ImageYUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    ImageY[ImageBox.ItemIndex] := NewValue;
  end;
end;

procedure TMainFrm.ImageTimeUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  If ImageBox.ItemIndex > -1 then
  begin
    ImageT[ImageBox.ItemIndex] := NewValue;
  end;
end;

procedure TMainFrm.MapObjectListClick(Sender: TObject);
begin
  eObjectX.Text := MapX[MapObjectList.ItemIndex];
  eObjectY.Text := MapY[MapObjectList.ItemIndex];
  ObjectImageBox.ItemIndex := MapImage[MapObjectList.ItemIndex];
  ObjectLayerBox.ItemIndex := MapLayer[MapObjectList.ItemIndex];
  If MapMode[MapObjectList.ItemIndex] <> -1 then
  begin
    ObjectModeBox.ItemIndex := MapMode[MapObjectList.ItemIndex];
  end
  ELSE
  begin
    ObjectModeBox.ItemIndex := 6;
  end;
  If MapTime[MapObjectList.ItemIndex] <> -1 then
  begin
    eObjectDsplyTime.Text := IntToStr(MapTime[MapObjectList.ItemIndex]);
  end
  ELSE
  begin
    eObjectDsplyTime.Text := '0';
  end;
  If MapID[MapObjectList.ItemIndex] <> -1 then
  begin
    eObjectID.Text := IntToStr(MapID[MapObjectList.ItemIndex]);
  end
  ELSE
  begin
    eObjectID.Text := '0';
  end;
end;

procedure TMainFrm.ScreenObjectListClick(Sender: TObject);
begin
  eObjectX.Text := ScreenX[ScreenObjectList.ItemIndex];
  eObjectY.Text := ScreenY[ScreenObjectList.ItemIndex];
  ObjectImageBox.ItemIndex := ScreenImage[ScreenObjectList.ItemIndex];
  ObjectLayerBox.ItemIndex := ScreenLayer[ScreenObjectList.ItemIndex];
  If ScreenMode[ScreenObjectList.ItemIndex] <> -1 then
  begin
    ObjectModeBox.ItemIndex := ScreenMode[ScreenObjectList.ItemIndex];
  end
  ELSE
  begin
    ObjectModeBox.ItemIndex := 6;
  end;
  If ScreenTime[ScreenObjectList.ItemIndex] <> -1 then
  begin
    eObjectDsplyTime.Text := IntToStr(ScreenTime[ScreenObjectList.ItemIndex]);
  end
  ELSE
  begin
    eObjectDsplyTime.Text := '0';
  end;
  If ScreenID[ScreenObjectList.ItemIndex] <> -1 then
  begin
    eObjectID.Text := IntToStr(ScreenID[ScreenObjectList.ItemIndex]);
  end
  ELSE
  begin
    eObjectID.Text := '0';
  end;
end;

procedure TMainFrm.AddObjectClick(Sender: TObject);
var newObject: String;
    Flag,i: Integer;
begin
  Flag := 0;

  If (Lowercase(Copy(eObjectX.Text,1,1)) = '@') and (Length(eObjectX.Text) > 1) then
  begin
    eObjectX.Text := IntToStr(StrToInt(Copy(eObjectX.Text,2,Length(eObjectX.Text))) * 16);
  end;
  If (Lowercase(Copy(eObjectY.Text,1,1)) = '@') and (Length(eObjectY.Text) > 1) then
  begin
    eObjectY.Text := IntToStr(StrToInt(Copy(eObjectY.Text,2,Length(eObjectY.Text))) * 16);
  end;

  newObject := eObjectX.Text + ',' + eObjectY.Text;
  newObject := newObject + ',IMAGE' + IntToStr(ObjectImageBox.ItemIndex);
  Case ObjectLayerBox.ItemIndex of
    0: newObject := newObject + ',BelowAll';
    1: newObject := newObject + ',AfterBackground';
    2: newObject := newObject + ',AfterTiles';
    3: newObject := newObject + ',AfterWeapons';
    4: newObject := newObject + ',AfterShips';
    5: newObject := newObject + ',AfterGauges';
    6: newObject := newObject + ',AfterChat';
    7: newObject := newObject + ',TopMost';
  end;
  If (ObjectModeBox.ItemIndex = -1) or (ObjectModeBox.ItemIndex = 6) then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    Case ObjectModeBox.ItemIndex of
      0: newObject := newObject + ',ShowAlways';
      1: newObject := newObject + ',EnterZone';
      2: newObject := newObject + ',EnterArena';
      3: newObject := newObject + ',Kill';
      4: newObject := newObject + ',Death';
      5: newObject := newObject + ',ServerControlled';
    end;
  end;
  If (eObjectDsplyTime.Text = '') then // or (eObjectDsplyTime.Text = '0') then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    newObject := newObject + ',' + eObjectDsplyTime.Text;
  end;
  If (eObjectID.Text = '') or (eObjectID.Text = '0') then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    newObject := newObject + ',' + eObjectID.Text;
  end;

  Case ObjectsBox.ItemIndex of
  -1,0: begin MapObjectList.Items.Add(newObject); UpdateArrays(True); end;
     1: begin ScreenObjectList.Items.Add(newObject); UpdateArrays(False); end;
  end;
  For i := 0 to ScreenObjectList.Items.Count -1 do
  begin
    ScreenObjectList.Selected[i] := False;
  end;
  ScreenObjectList.Selected[ScreenObjectList.Items.Count-1] := True;
  For i := 0 to MapObjectList.Items.Count -1 do
  begin
    MapObjectList.Selected[i] := False;
  end;
  MapObjectList.Selected[MapObjectList.Items.Count-1] := True;
end;

procedure TMainFrm.ApplyObjectClick(Sender: TObject);
var newObject: String;
    Flag,Index: Integer;
begin
  Flag := 0;

  If (Lowercase(Copy(eObjectX.Text,1,1)) = 't') and (Length(eObjectX.Text) > 1) then
  begin
    eObjectX.Text := IntToStr(StrToInt(Copy(eObjectX.Text,2,Length(eObjectX.Text))) * 16);
  end;
  If (Lowercase(Copy(eObjectY.Text,1,1)) = 't') and (Length(eObjectY.Text) > 1) then
  begin
    eObjectY.Text := IntToStr(StrToInt(Copy(eObjectY.Text,2,Length(eObjectY.Text))) * 16);
  end;

  newObject := eObjectX.Text + ',' + eObjectY.Text;
  newObject := newObject + ',IMAGE' + IntToStr(ObjectImageBox.ItemIndex);
  Case ObjectLayerBox.ItemIndex of
    0: newObject := newObject + ',BelowAll';
    1: newObject := newObject + ',AfterBackground';
    2: newObject := newObject + ',AfterTiles';
    3: newObject := newObject + ',AfterWeapons';
    4: newObject := newObject + ',AfterShips';
    5: newObject := newObject + ',AfterGauges';
    6: newObject := newObject + ',AfterChat';
    7: newObject := newObject + ',TopMost';
  end;
  If (ObjectModeBox.ItemIndex = -1) or (ObjectModeBox.ItemIndex = 6) then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    Case ObjectModeBox.ItemIndex of
      0: newObject := newObject + ',ShowAlways';
      1: newObject := newObject + ',EnterZone';
      2: newObject := newObject + ',EnterArena';
      3: newObject := newObject + ',Kill';
      4: newObject := newObject + ',Death';
      5: newObject := newObject + ',ServerControlled';
    end;
  end;
  If (eObjectDsplyTime.Text = '') then // or (eObjectDsplyTime.Text = '0') then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    newObject := newObject + ',' + eObjectDsplyTime.Text;
  end;
  If (eObjectID.Text = '') or (eObjectID.Text = '0') then
  begin
    Flag := 1;
  end;
  If (Flag <> 1) then
  begin
    newObject := newObject + ',' + eObjectID.Text;
  end;


  Case ObjectsBox.ItemIndex of
  -1,0: begin Index := MapObjectList.ItemIndex; MapObjectList.Items[MapObjectList.ItemIndex] := newObject; UpdateArrays(True); MapObjectList.Selected[Index] := True; end;
     1: begin Index := ScreenObjectList.ItemIndex; ScreenObjectList.Items[ScreenObjectList.ItemIndex] := newObject; UpdateArrays(False); ScreenObjectList.Selected[Index] := True; end;
  end;

end;

procedure TMainFrm.DelObjectClick(Sender: TObject);
begin
  Case ObjectsBox.ItemIndex of
  -1,0: begin MapObjectList.DeleteSelected; UpdateArrays(True); end;
     1: begin ScreenObjectList.DeleteSelected; UpdateArrays(False); end;
  end;
end;

procedure QSort(Links, Rechts: LongInt; SortBy: Integer; MapObject: Boolean);
var i,j,w: LongInt;
    ws,x: String;
begin
   i := Links;
   j := Rechts;
   x := '0';
   If MapObject then
   begin
     Case SortBy of
       0: x := MapX[(Links + Rechts) div 2];
       1: x := MapY[(Links + Rechts) div 2];
       2: x := IntToStr(MapImage[(Links + Rechts) div 2]);
       3: x := IntToStr(MapLayer[(Links + Rechts) div 2]);
       4: x := IntToStr(MapMode[(Links + Rechts) div 2]);
       5: x := IntToStr(MapTime[(Links + Rechts) div 2]);
       6: x := IntToStr(MapID[(Links + Rechts) div 2]);
     end;
   end
   ELSE
   begin
     Case SortBy of
       0: x := ScreenX[(Links + Rechts) div 2];
       1: x := ScreenY[(Links + Rechts) div 2];
       2: x := IntToStr(ScreenImage[(Links + Rechts) div 2]);
       3: x := IntToStr(ScreenLayer[(Links + Rechts) div 2]);
       4: x := IntToStr(ScreenMode[(Links + Rechts) div 2]);
       5: x := IntToStr(ScreenTime[(Links + Rechts) div 2]);
       6: x := IntToStr(ScreenID[(Links + Rechts) div 2]);
     end;
   end;
   if x = '0' then exit;
   repeat
     If MapObject then
     begin
       Case SortBy of
         0: begin while MapX[i] < x do Inc(i); while MapX[j] > x do Dec(j); end;
         1: begin while MapY[i] < x do Inc(i); while MapY[j] > x do Dec(j); end;
         2: begin while IntToStr(MapImage[i]) < x do Inc(i); while IntToStr(MapImage[j]) > x do Dec(j); end;
         3: begin while IntToStr(MapLayer[i]) < x do Inc(i); while IntToStr(MapLayer[j]) > x do Dec(j); end;
         4: begin while IntToStr(MapMode[i]) < x do Inc(i); while IntToStr(MapMode[j]) > x do Dec(j); end;
         5: begin while IntToStr(MapTime[i]) < x do Inc(i); while IntToStr(MapTime[j]) > x do Dec(j); end;
         6: begin while IntToStr(MapID[i]) < x do Inc(i); while IntToStr(MapID[j]) > x do Dec(j); end;
       end;
     end
     ELSE
     begin
       Case SortBy of
         0: begin while ScreenX[i] < x do Inc(i); while ScreenX[j] > x do Dec(j); end;
         1: begin while ScreenY[i] < x do Inc(i); while ScreenY[j] > x do Dec(j); end;
         2: begin while IntToStr(ScreenImage[i]) < x do Inc(i); while IntToStr(ScreenImage[j]) > x do Dec(j); end;
         3: begin while IntToStr(ScreenLayer[i]) < x do Inc(i); while IntToStr(ScreenLayer[j]) > x do Dec(j); end;
         4: begin while IntToStr(ScreenMode[i]) < x do Inc(i); while IntToStr(ScreenMode[j]) > x do Dec(j); end;
         5: begin while IntToStr(ScreenTime[i]) < x do Inc(i); while IntToStr(ScreenTime[j]) > x do Dec(j); end;
         6: begin while IntToStr(ScreenID[i]) < x do Inc(i); while IntToStr(ScreenID[j]) > x do Dec(j); end;
       end;
     end;
     if i <= j then
     begin
       If MapObject then
       begin
         w := MapImage[i];
         MapImage[i] := MapImage[j];
         MapImage[j] := w;

         ws := MapX[i];
         MapX[i] := MapX[j];
         MapX[j] := ws;

         ws := MapY[i];
         MapY[i] := MapY[j];
         MapY[j] := ws;

         w := MapLayer[i];
         MapLayer[i] := MapLayer[j];
         MapLayer[j] := w;

         w := MapMode[i];
         MapMode[i] := MapMode[j];
         MapMode[j] := w;

         w := MapTime[i];
         MapTime[i] := MapTime[j];
         MapTime[j] := w;

         w := MapID[i];
         MapID[i] := MapID[j];
         MapID[j] := w;
       end
       ELSE
       begin
         w := ScreenImage[i];
         ScreenImage[i] := ScreenImage[j];
         ScreenImage[j] := w;

         ws := ScreenX[i];
         ScreenX[i] := ScreenX[j];
         ScreenX[j] := ws;

         ws := ScreenY[i];
         ScreenY[i] := ScreenY[j];
         ScreenY[j] := ws;

         w := ScreenLayer[i];
         ScreenLayer[i] := ScreenLayer[j];
         ScreenLayer[j] := w;

         w := ScreenMode[i];
         ScreenMode[i] := ScreenMode[j];
         ScreenMode[j] := w;

         w := ScreenTime[i];
         ScreenTime[i] := ScreenTime[j];
         ScreenTime[j] := w;

         w := ScreenID[i];
         ScreenID[i] := ScreenID[j];
         ScreenID[j] := w;
       end;

       Inc(i);
       Dec(j);
     end;
   until i > j;
   if Links < j then QSort(Links,j,SortBy,MapObject);
   if Rechts > i then QSort(i,Rechts,SortBy,MapObject);
end;

procedure TMainFrm.SortObjectsClick(Sender: TObject);
begin
  SortFrm.Show;
  MainFrm.Enabled := False;

  Case ObjectsBox.ItemIndex of
    -1,0: begin
            SortFrm.SortMapObjects.Checked := True;
            SortFrm.SortScreenObjects.Checked := False;
          end;
       1: begin
            SortFrm.SortMapObjects.Checked := False;
            SortFrm.SortScreenObjects.Checked := True;
          end;
  end;

end;

procedure TMainFrm.eObjectXKeyPress(Sender: TObject; var Key: Char);
begin
  If (key = #13) and (Lowercase(Copy(eObjectX.Text,1,1)) = '@') and (Length(eObjectX.Text) > 1) then
  begin
    eObjectX.Text := IntToStr(StrToInt(Copy(eObjectX.Text,2,Length(eObjectX.Text))) * 16);
  end;
end;

procedure TMainFrm.eObjectYKeyPress(Sender: TObject; var Key: Char);
begin
If (key = #13) and (Lowercase(Copy(eObjectY.Text,1,1)) = '@') and (Length(eObjectY.Text) > 1) then
  begin
    eObjectY.Text := IntToStr(StrToInt(Copy(eObjectY.Text,2,Length(eObjectY.Text))) * 16);
  end;
end;

procedure TMainFrm.eObjectXExit(Sender: TObject);
begin
  If (Lowercase(Copy(eObjectX.Text,1,1)) = '@') and (Length(eObjectX.Text) > 1) then
  begin
    eObjectX.Text := IntToStr(StrToInt(Copy(eObjectX.Text,2,Length(eObjectX.Text))) * 16);
  end;
end;

procedure TMainFrm.eObjectYExit(Sender: TObject);
begin
  If (Lowercase(Copy(eObjectY.Text,1,1)) = '@') and (Length(eObjectY.Text) > 1) then
  begin
    eObjectY.Text := IntToStr(StrToInt(Copy(eObjectY.Text,2,Length(eObjectY.Text))) * 16);
  end;
end;

procedure TMainFrm.PresetsClick(Sender: TObject);
begin
  PresetPopUp.Popup(MainFrm.Left + ObjectsSection.Left + Presets.Left + 20, MainFrm.Top + ObjectsSection.Top + Presets.Top);
end;

procedure TMainFrm.CenterSafeClick(Sender: TObject);
var Pic: TBitmap;
    PicFile: String;
    PicWidth,PicHeight: Integer;
begin
  If (ObjectImageBox.ItemIndex <> -1) then
  begin
    PicFile := IniPath + ImageFile[ObjectImageBox.ItemIndex];
  end
  ELSE
  begin
    PicFile := '';
  end;
  If FileExists(PicFile) then
  begin
    Pic := TBitmap.Create;
    Pic.LoadFromFile(PicFile);
    PicWidth := Pic.Width;
    PicHeight := Pic.Height;
    Pic.Free;

    eObjectX.Text := IntToStr(Trunc(8200 - PicWidth div 2));
    eObjectY.Text := IntToStr(Trunc(8200 - PicHeight div 2));
    ObjectLayerBox.ItemIndex := 2;
    ObjectModeBox.ItemIndex := 6;
    eObjectDsplyTime.Text := '0';
    eObjectID.Text := '0';

    ObjectsBox.ItemIndex := 0;
    ScreenObjectList.Visible := False;
    MapObjectList.Visible := True;
  end;
end;

procedure TMainFrm.SplashScreenCenterClick(Sender: TObject);
var Pic: TBitmap;
    PicFile: String;
    PicWidth,PicHeight: Integer;
begin
  If (ObjectImageBox.ItemIndex <> -1) then
  begin
    PicFile := IniPath + ImageFile[ObjectImageBox.ItemIndex];
  end
  ELSE
  begin
    PicFile := '';
  end;
  If FileExists(PicFile) then
  begin
    Pic := TBitmap.Create;
    Pic.LoadFromFile(PicFile);
    PicWidth := Pic.Width;
    PicHeight := Pic.Height;
    Pic.Free;

    eObjectX.Text := 'C-' + IntToStr(Trunc(PicWidth div 2));
    eObjectY.Text := 'C-' + IntToStr(Trunc(PicHeight div 2));
    ObjectLayerBox.ItemIndex := 7;
    ObjectModeBox.ItemIndex := 1;
    eObjectDsplyTime.Text := '2000';
    eObjectID.Text := '0';

    ObjectsBox.ItemIndex := 1;
    ScreenObjectList.Visible := True;
    MapObjectList.Visible := False;
  end;
end;

procedure TMainFrm.SwitchClick(Sender: TObject);
var i,Flag: Integer;
begin
  Flag := 0;
  If (ObjectsBox.ItemIndex < 1) then
  begin
    For i := 0 to MapObjectList.Items.Count - 1 do
    begin
      If MapObjectList.Selected[i] then
      begin
        ScreenObjectList.Items.Add(MapObjectList.Items[i]);
      end;
    end;
    ObjectsBox.ItemIndex := 1;
    ScreenObjectList.Visible := True;
    MapObjectList.Visible := False;
    UpdateArrays(False);
    Flag := 1;
  end;
  If (ObjectsBox.ItemIndex = 1) and (Flag = 0) then
  begin
    For i := 0 to ScreenObjectList.Items.Count - 1 do
    begin
      If ScreenObjectList.Selected[i] then
      begin
        MapObjectList.Items.Add(ScreenObjectList.Items[i]);
      end;
    end;
    ObjectsBox.ItemIndex := 0;
    ScreenObjectList.Visible := False;
    MapObjectList.Visible := True;
    UpdateArrays(True);
  end;
end;

procedure TMainFrm.aOpenExecute(Sender: TObject);
begin
  If (OpenFileDialog.Execute) then
  begin
    NewIni;
    Ini := OpenFileDialog.FileName;
    Open(Ini);
    IniPath := ExtractFilePath(Ini);
    MainFrm.Caption := Title + ' - ' + ExtractFileName(Ini);
    Status.Panels[0].Text := Ini;
  end;
end;

procedure TMainFrm.Options1Click(Sender: TObject);
begin
  OptnsForm.Show;
  MainFrm.Enabled := False;
end;

procedure TMainFrm.NewExecute(Sender: TObject);
begin
  NewIni;
end;

procedure TMainFrm.SaveAsExecute(Sender: TObject);
var Datei: String;
begin
  If (SaveFileDialog.Execute) then
  begin
    Datei := SaveFileDialog.FileName;
    If (Datei <> '') then
    begin
      If (ExtractFileExt(Datei) = '') then Datei := Datei + '.ini';
      SaveIni(Datei);
    end;
  end;
end;

procedure TMainFrm.SaveExecute(Sender: TObject);
var Datei: String;
begin
  If (Ini <> '') then
  begin
    SaveIni(Ini);
  end
  ELSE
  begin
    If (SaveFileDialog.Execute) then
    begin
      Datei := SaveFileDialog.FileName;
      If (Datei <> '') then
      begin
        If (ExtractFileExt(Datei) = '') then Datei := Datei + '.ini';
        SaveIni(Datei);
      end;
    end;
  end;
end;

procedure TMainFrm.CompileExecute(Sender: TObject);
begin
  If (Compiler <> '') then
  begin
    If (Ini <> '') then
    begin
      SaveIni(Ini);
      WinExec(PChar(Compiler + ' ' + Ini), 1);
    end
    ELSE
    begin
      MessageDlg('Ini not saved or no ini opened!', mtError, [mbOk], 0);
    end;
  end
  ELSE
  begin
    MessageDlg('No Compiler selected, select one from the options screen!', mtError, [mbOk], 0);
  end;
end;

procedure TMainFrm.LieHelp1Click(Sender: TObject);
begin
  Application.HelpKeyword('What'+#39+'s new?');
end;

procedure TMainFrm.About1Click(Sender: TObject);
begin
  AboutFrm.Show;
  MainFrm.Enabled := False;
end;

procedure TMainFrm.ExitExecute(Sender: TObject);
begin
  MainFrm.Close;
end;

procedure TMainFrm.AnimTimerTimer(Sender: TObject);
begin
  If Anim then
  begin
    Image.Picture.Assign(PicClip.Cells[XTile,YTile]);
    XTile := XTile + 1;
    If XTile > PicClip.Cols-1 then
    begin
      XTile := 0;
      YTile := YTile + 1;
      If YTile > PicClip.Rows-1 then
      begin
        YTile := 0;
      end;
    end;
  end;
end;

procedure TMainFrm.ImageXUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  If Anim then HideImage;
end;

procedure TMainFrm.BackgroundTiledMajick1Click(Sender: TObject);
var Pic: TBitmap;
    PicFile: String;
    PicWidth,PicHeight,TMX,TMY: Integer;
begin
  If (ObjectImageBox.ItemIndex <> -1) then
  begin
    PicFile := IniPath + ImageFile[ObjectImageBox.ItemIndex];
  end
  ELSE
  begin
    PicFile := '';
  end;
  If FileExists(PicFile) then
  begin
    Pic := TBitmap.Create;
    Pic.LoadFromFile(PicFile);
    PicWidth := Pic.Width;
    PicHeight := Pic.Height;
    Pic.Free;
    TMX := 0;
    TMY := 0;
    repeat
      repeat
        MapObjectList.Items.Add(IntToStr(TMX) + ',' + IntToStr(TMY) + ',' + 'IMAGE' + IntToStr(ObjectImageBox.ItemIndex) + ',' + 'AfterBackground');
        TMY := TMY + PicHeight;
      until (TMY >= 16385);
      TMY := 0;
      TMX := TMX + PicWidth;
    until (TMX >= 16385);
    updateArrays(True);
  end;
end;

end.
